(*------------------------------------------------------------
TEAM07
A
172
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library ospu1;
uses
  Math,
  Ants in 'Ants.pas',
  Windows;

const
  PLAYER_NAME = ' 1';
  GuardsNumber = 3;

type
  TRole = (newborn, guard, getter, warrior, thief);

const
  HillsDir: array [1..4, 1..2] of integer = ( (-1, -1), (-1, 1), (1, 1), (1, -1));
  HillsOrd: array [1..4, 1..2] of TAntActionType = ((aaMoveUp, aaMoveLeft), (aaMoveUp, aaMoveRight),
    (aaMoveDown, aaMoveRight), (aaMoveDown, aaMoveLeft));

  OutHillsDir: array [1..4, 1..2] of integer = ( (1, 1), (1, -1), (-1, -1), (-1, 1));
  OutHillsOrd: array [1..4, 1..2] of TAntActionType = ((aaMoveDown, aaMoveRight), (aaMoveDown, aaMoveLeft),
    (aaMoveUp, aaMoveLeft), (aaMoveUp, aaMoveRight));

function GetRole(memory:PMemory): TRole;
begin
  case memory^[0] of
    0: result := newborn;
    1: result := guard;
    2: result := getter;
    3: result := warrior;
    4: result := thief;
  else
    result := getter;
  end
end;

procedure SetRole(var memory:PMemory; role: TRole);
begin
  case role of
    newborn: memory^[0] := 0;
    guard:   memory^[0] := 1;
    getter:  memory^[0] := 2;
    warrior: memory^[0] := 3;
    thief:   memory^[0] := 4;
  end;
end;

function GetNumber(memory:PMemory): Byte;
begin
  result := memory^[4];
end;

procedure SetNumber(var memory:PMemory; number: byte);
begin
  memory^[4] := number;
end;

function GetMove(memory:PMemory): Word;
begin
  result := memory^[5] + memory^[6] shl 8;
end;

procedure SetMove(var memory:PMemory; number: word);
begin
  memory^[5] := number shr 8;
  memory^[6] := number mod 256;
end;

function GetMyHill(memory:PMemory): byte;
begin
  result := memory^[3];
end;

procedure SetMyHill(var memory:PMemory; number: byte);
begin
  memory^[3] := number;
end;

function GetI(memory:PMemory): byte;
begin
  result := memory^[1];
end;

procedure SetI(var memory:PMemory; number: byte);
begin
  memory^[1] := number;
end;

function GetJ(memory:PMemory): byte;
begin
  result := memory^[2];
end;

procedure SetJ(var memory:PMemory; number: byte);
begin
  memory^[2] := number;
end;

function GetPrevMove(memory:PMemory): byte;
begin
  result := memory^[13];
end;

procedure SetPrevMove(var memory:PMemory; number: byte);
begin
  memory^[13] := number;
end;

procedure NewBornMove(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction);
begin
  if (sensors[0, 0].smellIntensity = 0) then
  begin
    result.putSmell := true;
    result.smell := 1;
    SetNumber(memory, 1);
    SetMove(memory, 1);
    Randomize;    
  end
  else
  begin
    SetNumber(memory, sensors[0, 0].smell + 1);
    SetMove(memory, sensors[0, 0].smell + 1);
    result.putSmell := true;
    result.smell := sensors[0, 0].smell + 1;
  end;

  if (sensors[-1, -1].isWall) then
    SetMyHill(memory, 1)
  else if (sensors[1, -1].isWall) then
    SetMyHill(memory, 2)
  else if (sensors[1, 1].isWall) then
    SetMyHill(memory, 3)
  else if (sensors[-1, 1].isWall) then
    SetMyHill(memory, 4);

  if (GetNumber(memory) <= GuardsNumber) then
    SetRole(memory, guard)
  else
  begin
    SetRole(memory, getter);
  end;
end;

procedure GetterGoToHill(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction);
var
  MyHill: byte;
  CanI, CanJ: Boolean;
begin
  MyHill := GetMyHill(memory);

  CanI := not sensors[0, HillsDir[MyHill, 1]].isWall;
  CanJ := not sensors[HillsDir[MyHill, 2], 0].isWall;

  if (sensors[0, 1].isEnemy and (GetPrevMove(memory) <> 1)) then
  begin
    result.actionType := aaBiteDown;
    SetPrevMove(memory, 1);
  end
  else if (sensors[0, -1].isEnemy and (GetPrevMove(memory) <> 2)) then
  begin
    result.actionType := aaBiteUp;
    SetPrevMove(memory, 2);
  end
  else if (sensors[-1, 0].isEnemy and (GetPrevMove(memory) <> 3)) then
  begin
    result.actionType := aaBiteLeft;
    SetPrevMove(memory, 3);
  end
  else if (sensors[1, 0].isEnemy and (GetPrevMove(memory) <> 4)) then
  begin
    result.actionType := aaBiteRight;
    SetPrevMove(memory, 4);
  end
  else if (CanI and CanJ) then
  begin
    SetPrevMove(memory, 0);
    if (Random(2) = 1) then
      result.actionType := HillsOrd[MyHill, 1]
    else
      result.actionType := HillsOrd[MyHill, 2];
  end
  else if canI then
  begin
    result.actionType := HillsOrd[MyHill, 1];
        SetPrevMove(memory, 0);
    end
  else
  begin
    result.actionType := HillsOrd[MyHill, 2];
        SetPrevMove(memory, 0);
    end;
end;

function Inverse(a: TAntActionType): TAntActionType;
begin
  if a = aaMoveUp then
    result := aaMoveDown
  else if a = aaMoveDown then
    result := aaMoveUp
  else if a = aaMoveLeft then
    result := aaMoveRight
  else
    Result := aaMoveLeft;
end;

procedure GetterGetFood(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction);
var
  MyHill: byte;
  CanI, CanJ: Boolean;
  x: integer;
begin
  if (sensors[0, 1].isEnemy and (GetPrevMove(memory) <> 1)) then
  begin
    result.actionType := aaBiteDown;
    SetPrevMove(memory, 1);
  end
  else if (sensors[0, -1].isEnemy and (GetPrevMove(memory) <> 2)) then
  begin
    result.actionType := aaBiteUp;
    SetPrevMove(memory, 2);
  end
  else if (sensors[-1, 0].isEnemy and (GetPrevMove(memory) <> 3)) then
  begin
    result.actionType := aaBiteLeft;
    SetPrevMove(memory, 3);
  end
  else if (sensors[1, 0].isEnemy and (GetPrevMove(memory) <> 4)) then
  begin
    result.actionType := aaBiteRight;
    SetPrevMove(memory, 4);
  end
  else if (sensors[0, 0].isFood) and (not hasFood) and (not sensors[0, 0].isMyHill) then
  begin
    result.actionType := aaGet;
    SetPrevMove(memory, 0);
  end
  else
  begin
    SetPrevMove(memory, 0);
    MyHill := GetMyHill(memory);

    CanI := not sensors[0, OutHillsDir[MyHill, 1]].isWall;
    CanJ := not sensors[OutHillsDir[MyHill, 2], 0].isWall;

    if (CanI and CanJ) then
    begin
      x := Random(2);

      if (sensors[0, OutHillsDir[MyHill, 1]].isFood) then
        x := x + 1;
      if (sensors[OutHillsDir[MyHill, 2], 0].isFood) then
        x := x - 1;

      if (x >= 1) then
        result.actionType := OutHillsOrd[MyHill, 1]
      else
        result.actionType := OutHillsOrd[MyHill, 2];
    end
    else if canI then
    begin
      if (Random(2) = 1) then
        result.actionType := OutHillsOrd[MyHill, 1]
      else
        result.actionType := Inverse(OutHillsOrd[MyHill, 2]);
    end
    else
    begin
      if (Random(2) = 1) then
        result.actionType := OutHillsOrd[MyHill, 2]
      else
        result.actionType := Inverse(OutHillsOrd[MyHill, 1]);
    end;
  end;
end;

procedure GetterMove(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction);
begin
  if (hasfood and sensors[0, 0].isMyHill) then
  begin
    result.actionType := aaPut;
  end
  else if (not hasfood) then
    GetterGetFood(sensors, hasFood, memory, result)
  else if (hasFood) then
    GetterGoToHill(sensors, hasFood, memory, result);
end;

procedure GuardMove(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction);
begin
  if (sensors[0, 1].isEnemy and (GetPrevMove(memory) <> 1)) then
  begin
    result.actionType := aaBiteDown;
    SetPrevMove(memory, 1);
  end
  else if (sensors[0, -1].isEnemy and (GetPrevMove(memory) <> 2)) then
  begin
    result.actionType := aaBiteUp;
    SetPrevMove(memory, 2);
  end
  else if (sensors[-1, 0].isEnemy and (GetPrevMove(memory) <> 3)) then
  begin
    result.actionType := aaBiteLeft;
    SetPrevMove(memory, 3);
  end
  else if (sensors[1, 0].isEnemy and (GetPrevMove(memory) <> 4)) then
  begin
    result.actionType := aaBiteRight;
    SetPrevMove(memory, 4);
  end
  else if ( (GetNumber(memory) mod 2 = 0) and sensors[0, 0].isMyHill and (GetNumber(memory) <> 1)) then
    result.actionType := OutHillsOrd[GetMyHill(memory), 1]
  else if ( (GetNumber(memory) mod 2 = 1) and sensors[0, 0].isMyHill and (GetNumber(memory) <> 1)) then
    result.actionType := OutHillsOrd[GetMyHill(memory), 2];
end;

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;
var
  Role: TRole;
begin
  Role := GetRole(memory);

  if ((Role <> Newborn) and (not( sensors[0, 0].isMyHill))) then
  begin
    SetMove(memory, GetMove(memory) + 1);
    if Random(3) = 0 then
    begin
      result.putSmell := true;
      result.smell := RandomRange(-maxint, maxint);
    end;
  end;

  case Role of
    newborn: NewBornMove(sensors, hasFood, memory, result);
    getter: GetterMove(sensors, hasFood, memory, result);
    guard: GuardMove(sensors, hasFood, memory, result);
  end;
end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
end.

