(*------------------------------------------------------------
TEAM16
A
177
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library DelphiSamplePlayer;
uses
  Math,
  Ants in 'Ants.pas';

const
  PLAYER_NAME = 'UCS';
  ZP_UKUS =  734653;
  ZP_STRAG = 134325;

var init, nSpecCount:integer;

procedure GetXY(Direction:Byte; var x, y:shortint);
begin
    x:=0;
    y:=0;
    case direction of
        0:y:=1;
        1:x:=-1;
        2:y:=-1;
        3:x:=1;
    end;
end;

function Ukus(sensors: TSensors; bStrag:boolean):integer;
var i, j:integer;
begin
    Ukus:=-1;
    if (NOT bStrag) AND (sensors[0, 0].smellIntensity>98) AND (sensors[0, 0].smell=ZP_UKUS) then exit;
    for i:=-1 to 1 do
        for j:=-1 to 1 do
        begin
            if (sensors[i, j].isEnemy) then
            begin
                if (i=-1) AND (j=0) then Ukus:=Integer(aaBiteLeft);
                if (i=0) AND (j=1) then Ukus:=Integer(aaBiteDown);
                if (i=1) AND (j=0) then Ukus:=Integer(aaBiteRight);
                if (i=0) AND (j=1) then Ukus:=Integer(aaBiteUp);
            end;
        end;
end;

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;
var
  X, Y, nx, ny: shortint;
  position: Byte;
  direction: Byte;
  k:integer;
  nap : Byte;
  bWall : boolean;
  bStrag : boolean;
begin
    if (init<>21546) then
    begin
        init:=21546;
        Randomize();
    end;
    if nSpecCount=0 then
    begin
        memory[4]:=1;
        Inc(nSpecCount);
    end;

    bStrag := shortint(memory[4])=1;
  if hasFood and sensors[0][0].isMyHill then
    result.actionType := aaPut
  else if not hasFood and not sensors[0][0].isMyHill and sensors[0][0].isFood then
    result.actionType := aaGet
  else
  begin
    X := shortint(memory[1]);
    Y := shortint(memory[2]);
    nap := shortint(memory[3]);
    k:=Ukus(sensors, bStrag);
    if k<>-1 then
    begin
        result.actionType:=TAntActionType(k);
        result.putSmell := true;
        result.smell := ZP_UKUS;
        Exit;
    end;
    if (bStrag) then Exit;
    if hasFood then
    begin
        if (x<0) then
        begin
            inc(x);
            direction:=3;
        end
        else if (x>0) then
        begin
            dec(x);
            direction:=1;
        end
        else if (y<0) then
        begin
            inc(y);
            direction:=0;
        end
        else if (y>0) then
        begin
            dec(y);
            direction:=2;
        end;
    end else begin
        //direction := memory[3];
        //if direct
        repeat
            bWall:=false;
            direction:=(random(2)+nap) mod 4;
            GetXY(direction, nx, ny);
            if (sensors[nx, -ny].isWall) then
            begin
                nap:=random(4);
                bWall:=true;
            end;
        until NOT bWall;
        x:=x+nx;
        y:=y+ny;
    end;
    memory[1] := X;
    memory[2] := Y;
    memory[3] := nap;
    result.actionType := TAntActionType(direction);
  end;
  result.putSmell := false;
end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
end.

