/*------------------------------------------------------------
TEAM35
A
180
Target: AntsCpp; Platform: Win32; Comment: MS Visual C++ 6 (Ants, dll)
------------------------------------------------------------*/
#include "windows.h"
#include "Ants.h"
#include <math.h>

#define PLAYER_NAME "Self-propelled Ant Unit (SAU)"

/*Memory:
 1 - number
 2 - type
 3 - total
 4 - x
 5 - y
 6 - turn
 10- corner
 guard:
 7 - base dir
 8 - major dir
 9 - minor dir
 worker:
 partisan:
*/

//---------------common----------------

char NUM(char memory[MAX_MEMORY]){
	return memory[1];
}

char TYPE(char memory[MAX_MEMORY]){
	return memory[2];
}

char TOTAL(char memory[MAX_MEMORY]){
	return memory[3];
}

char X(char memory[MAX_MEMORY]){
	return memory[4];
}

char Y(char memory[MAX_MEMORY]){
	return memory[5];
}

char TURN(char memory[MAX_MEMORY]){
	return memory[6];
}

char getCorner(char memory[MAX_MEMORY]){
	return memory[10];
}

//------------guard-------------------

char getGuardBaseDir(char memory[MAX_MEMORY]){
	return memory[7];
}

void setGuardBaseDir(char memory[MAX_MEMORY], char dir){
	memory[7] = dir;
}

char getGuardMajorDir(char memory[MAX_MEMORY]){
	return memory[8];
}

void setGuardMajorDir(char memory[MAX_MEMORY], char dir){
	memory[8] = dir;
}

char getGuardMinorDir(char memory[MAX_MEMORY]){
	return memory[9];
}

void setGuardMinorDir(char memory[MAX_MEMORY], char dir){
	memory[9] = dir;
}

AntSensor getSense (AntSensor sensors[3][3], char curdir)
{
	switch (curdir)
	{
	case 0:
		return sensors[1][1];
	case 1:
		return sensors[2][1];
	case 2:
		return sensors[1][2];
	case 3:
		return sensors[0][1];
	case 4:
		return sensors[1][0];
	}
	return sensors[1][1];
}

//------------actions--------------

AntAction guard(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY]){
	AntAction res;
	if (getGuardMajorDir(memory) == 0)
	{
		if ((X(memory) == 1) && (Y(memory) == 0))
		{
			setGuardMajorDir(memory,1);
			setGuardBaseDir(memory,3);
			if (getSense(sensors,4).isWall)
			{
				setGuardMinorDir(memory,2);
			}
			else
			{
				setGuardMinorDir(memory,4);
			}
		}
		if ((X(memory) == 0) && (Y(memory) == 1))
		{
			setGuardMajorDir(memory,4);
			setGuardBaseDir(memory,2);
			if (getSense(sensors,1).isWall)
			{
				setGuardMinorDir(memory,3);
			}
			else
			{
				setGuardMinorDir(memory,1);
			}
		}
		if ((X(memory) == -1) && (Y(memory) == 0))
		{
			setGuardMajorDir(memory,3);
			setGuardBaseDir(memory,1);
			if (getSense(sensors,4).isWall)
			{
				setGuardMinorDir(memory,2);
			}
			else
			{
				setGuardMinorDir(memory,4);
			}
		}
		if ((X(memory) == 0) && (Y(memory) == -1))
		{
			setGuardMajorDir(memory,2);
			setGuardBaseDir(memory,4);
			if (getSense(sensors,1).isWall)
			{
				setGuardMinorDir(memory,3);
			}
			else
			{
				setGuardMinorDir(memory,1);
			}
		}
		res.actionType = PUT;
		res.putSmell = true;
		res.smell = 1;
	}
	else
	{
		char dir[4];
		char curdir;
		dir[1] = getGuardBaseDir(memory);
		dir[2] = getGuardMajorDir(memory);
		dir[3] = getGuardMinorDir(memory);
		curdir = getSense(sensors,0).smell;
		if (getSense(sensors,dir[curdir]).isEnemy)
		{
			res.actionType = (AntActionType)(8 - dir[curdir]);
			res.putSmell = true;
			res.smell = curdir % 3 + 1;
		}
		else if (getSense(sensors,dir[curdir % 3 + 1]).isEnemy)
		{
			res.actionType = (AntActionType)(8 - dir[curdir % 3 + 1]);
			res.putSmell = true;
			res.smell = (curdir + 1) % 3 + 1;
		}
		else
		{
			res.actionType = (AntActionType)(8 - dir[(curdir + 1) % 3 + 1]);
			res.putSmell = true;
			res.smell = curdir;
		}
	}
	return res;
}

//------------------------------worker--------------------------

void countDanger(AntSensor sensors[3][3], char danger[3][3]){
	if (sensors[0][0].isEnemy){
		danger[0][1] = 1;
		danger[1][0] = 1;
	}
	if (sensors[0][1].isEnemy){
		danger[0][0] = 1;
		danger[0][2] = 1;
		danger[1][1] = 1;
	}
	if (sensors[0][2].isEnemy){
		danger[0][1] = 1;
		danger[1][2] = 1;
	}
	if (sensors[1][0].isEnemy){
		danger[0][0] = 1;
		danger[1][1] = 1;
		danger[2][0] = 1;
	}
	if (sensors[1][1].isEnemy){
		danger[0][1] = 1;
		danger[1][0] = 1;
		danger[1][2] = 1;
		danger[2][1] = 1;
	}
	if (sensors[1][2].isEnemy){
		danger[0][2] = 1;
		danger[2][2] = 1;
		danger[1][1] = 1;
	}
	if (sensors[2][0].isEnemy){
		danger[1][0] = 1;
		danger[2][1] = 1;
	}
	if (sensors[2][1].isEnemy){
		danger[2][0] = 1;
		danger[2][2] = 1;
		danger[1][1] = 1;
	}
	if (sensors[2][2].isEnemy){
		danger[2][1] = 1;
		danger[1][2] = 1;
	}
	return;
}

AntAction worker(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY]){
	AntAction res;
	char danger[3][3] = {0};
	int i, j, k, ok, r;
	if (!hasFood){
		if ((!sensors[1][1].isMyHill)&&(sensors[1][1].isFood)){
			res.actionType = GET;
			return res;
		}
		countDanger(sensors, danger);
		ok = 0;
		for (i=0; i<3; i++){
			for (j=0; j<3; j++){
				if ((labs(i-1) != labs(j-1))&&(sensors[i][j].isFood)&&(!danger[i][j])){
					ok = 1;
					k = 2*i + j;
					switch (k){
						case 1: res.actionType = MOVE_LEFT;
						case 2: res.actionType = MOVE_UP;
						case 4: res.actionType = MOVE_DOWN;
						case 5: res.actionType = MOVE_RIGHT;
					}
				}
			}
		}
		if (!ok){
			srand(1);
			r = rand()%2;
			if ((X(memory) >= 0) && (Y(memory) >= 0)){
				if (r == 0){
					if ((!danger[2][1])&&(!sensors[2][1].isWall)){
						res.actionType = MOVE_RIGHT;
					}
					else if ((!danger[1][0])&&(!sensors[1][0].isWall)){
						res.actionType = MOVE_UP;
					}
					else if ((!danger[0][1])&&(!sensors[0][1].isWall)){
						res.actionType = MOVE_LEFT;
					}
					else if ((!danger[1][2])&&(!sensors[1][2].isWall)){
						res.actionType = MOVE_DOWN;
					}
					else{
						res.actionType = PUT;
					}
				}
				if (r == 1){
					if ((!danger[1][0])&&(!sensors[1][0].isWall)){
						res.actionType = MOVE_UP;
					}
					else if ((!danger[2][1])&&(!sensors[2][1].isWall)){
						res.actionType = MOVE_RIGHT;
					}
					else if ((!danger[1][2])&&(!sensors[1][2].isWall)){
						res.actionType = MOVE_DOWN;
					}
					else if ((!danger[0][1])&&(!sensors[0][1].isWall)){
						res.actionType = MOVE_LEFT;
					}
					else{
						res.actionType = PUT;
					}
				}
			}
			if ((X(memory) >= 0) && (Y(memory) <= 0)){
				if (r == 0){
					if ((!danger[2][1])&&(!sensors[2][1].isWall)){
						res.actionType = MOVE_RIGHT;
					}
					else if ((!danger[1][2])&&(!sensors[1][2].isWall)){
						res.actionType = MOVE_DOWN;
					}
					else if ((!danger[0][1])&&(!sensors[0][1].isWall)){
						res.actionType = MOVE_LEFT;
					}
					else if ((!danger[1][0])&&(!sensors[1][0].isWall)){
						res.actionType = MOVE_UP;
					}
					else{
						res.actionType = PUT;
					}
				}
				if (r == 1){
					if ((!danger[1][2])&&(!sensors[1][2].isWall)){
						res.actionType = MOVE_DOWN;
					}
					else if ((!danger[2][1])&&(!sensors[2][1].isWall)){
						res.actionType = MOVE_RIGHT;
					}
					else if ((!danger[1][0])&&(!sensors[1][0].isWall)){
						res.actionType = MOVE_UP;
					}
					else if ((!danger[0][1])&&(!sensors[0][1].isWall)){
						res.actionType = MOVE_LEFT;
					}
					else{
						res.actionType = PUT;
					}
				}
			}
			if ((X(memory) <= 0) && (Y(memory) <= 0)){
				if (r == 0){
					if ((!danger[0][1])&&(!sensors[0][1].isWall)){
						res.actionType = MOVE_LEFT;
					}
					else if ((!danger[1][2])&&(!sensors[1][2].isWall)){
						res.actionType = MOVE_DOWN;
					}
					else if ((!danger[2][1])&&(!sensors[2][1].isWall)){
						res.actionType = MOVE_RIGHT;
					}
					else if ((!danger[1][0])&&(!sensors[1][0].isWall)){
						res.actionType = MOVE_UP;
					}
					else{
						res.actionType = PUT;
					}
				}
				if (r == 1){
					if ((!danger[1][2])&&(!sensors[1][2].isWall)){
						res.actionType = MOVE_DOWN;
					}
					else if ((!danger[0][1])&&(!sensors[0][1].isWall)){
						res.actionType = MOVE_LEFT;
					}
					else if ((!danger[1][0])&&(!sensors[1][0].isWall)){
						res.actionType = MOVE_UP;
					}
					else if ((!danger[2][1])&&(!sensors[2][1].isWall)){
						res.actionType = MOVE_RIGHT;
					}
					else{
						res.actionType = PUT;
					}
				}
			}
			if ((X(memory) <= 0) && (Y(memory) >= 0)){
				if (r == 0){
					if ((!danger[1][0])&&(!sensors[1][0].isWall)){
						res.actionType = MOVE_UP;
					}
					else if ((!danger[0][1])&&(!sensors[0][1].isWall)){
						res.actionType = MOVE_LEFT;
					}
					else if ((!danger[1][2])&&(!sensors[1][2].isWall)){
						res.actionType = MOVE_DOWN;
					}
					else if ((!danger[2][1])&&(!sensors[2][1].isWall)){
						res.actionType = MOVE_RIGHT;
					}
					else{
						res.actionType = PUT;
					}
				}
				if (r == 1){
					if ((!danger[0][1])&&(!sensors[0][1].isWall)){
						res.actionType = MOVE_LEFT;
					}
					else if ((!danger[1][0])&&(!sensors[1][0].isWall)){
						res.actionType = MOVE_UP;
					}
					else if ((!danger[2][1])&&(!sensors[2][1].isWall)){
						res.actionType = MOVE_RIGHT;
					}
					else if ((!danger[1][2])&&(!sensors[1][2].isWall)){
						res.actionType = MOVE_DOWN;
					}
					else{
						res.actionType = PUT;
					}
				}
			}
		}
		return res;
	}
	else{
		if (X(memory) != 0){
			if (X(memory) < 0){
				res.actionType = MOVE_RIGHT;
			}
			else{
				res.actionType = MOVE_LEFT;
			}
		}
		else if (Y(memory) != 0){
			if (Y(memory) < 0){
				res.actionType = MOVE_UP;
			}
			else{
				res.actionType = MOVE_DOWN;
			}
		}
		else{
			res.actionType = PUT;
		}
		return res;
	}
}

//----------------------partisan------------------

AntAction partisan(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY]){
	AntAction res;

	return res;
}

//------------------common---------------------

AntAction GetAntAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY])
{
	AntAction result;
	/*if (hasFood && sensors[1][1].isMyHill) result.actionType = PUT;
	else if (!hasFood && !sensors[1][1].isMyHill && sensors[1][1].isFood) result.actionType = GET;
	else
	{
		char spiralSize = max(10, memory[0]);
		char position = memory[1];
		char direction = memory[2];
		position = position % spiralSize;
		if (position == 0)
		{
			if (direction == 3) spiralSize = max(10, (spiralSize + 1) % 41);
			direction = (direction + 1) % 4;
		}
		position++;
		memory[0] = spiralSize;
		memory[1] = position;
		memory[2] = direction;
		result.actionType = AntActionType(direction);
	}*/
	// move first time
	if (memory[1] == 0){
		result.putSmell = true;
		result.smell = sensors[1][1].smell + 1;
		memory[1] = result.smell;
		memory[6] = 1;
		if (!sensors[0][0].isWall){
			memory[10] = 0;
		}
		if (!sensors[2][0].isWall){
			memory[10] = 1;
		}
		if (!sensors[2][2].isWall){
			memory[10] = 2;
		}
		if (!sensors[0][2].isWall){
			memory[10] = 3;
		}
		if (memory[1] % 2){
			if (sensors[1][0].isWall){
				memory[4] = 0;
				memory[5] = -1;
				result.actionType = MOVE_DOWN;
			}
			else{
				memory[4] = 0;
				memory[5] = 1;
				result.actionType = MOVE_UP;
			}
		}
		else{
			if (sensors[0][1].isWall){
				memory[4] = 1;
				memory[5] = 0;
				result.actionType = MOVE_RIGHT;
			}
			else{
				memory[4] = -1;
				memory[5] = 0;
				result.actionType = MOVE_LEFT;
			}
		}
		return result;
	}
	// init types
	else if (TURN(memory) == 1){
		memory[6]++;
		if ((X(memory) == 1) && (Y(memory) == 0)){
			memory[3] = sensors[0][1].smell;
		}
		if ((X(memory) == 0) && (Y(memory) == 1)){
			memory[3] = sensors[1][2].smell;
		}
		if ((X(memory) == -1) && (Y(memory) == 0)){
			memory[3] = sensors[2][1].smell;
		}
		if ((X(memory) == 0) && (Y(memory) == -1)){
			memory[3] = sensors[1][0].smell;
		}
		if (TOTAL(memory) == 10){
			memory[2] = 2;
		}
		else{
			if (NUM(memory) <= 6){
				memory[2] = 1;
			}
			/*else if (NUM(memory) >= 11){
				memory[2] = 3;
			}*/
			else{
				memory[2] = 2;
			}
		}
	}
	//new turn
	memory[6]++;
	if (TYPE(memory) == 1){
		return guard(sensors, hasFood, memory);
	}
	else if (TYPE(memory) == 2){
		return worker(sensors, hasFood, memory);
	}
	else {
		return partisan(sensors, hasFood, memory);
	};
//	return result;
}

char* __stdcall GetName()
{
	return PLAYER_NAME;
}

