(*------------------------------------------------------------
TEAM38
A
179
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library GosuAnt;
uses
  Ants in 'Ants\templates\Delphi\Ants.pas';

const
  PLAYER_NAME = 'IzhSTU Gods of Ants';
  maxAnts = 20;

  mTime = 0;
  mNumber = 1;

  smStart = 100;

  mpWall = -1;
  mpEmpty = 0;
  mpFood = 1;
  mpBase = 2;
  mpEnemyBase = 3;

type
  TAntStats = record
    x, y, orderx, ordery: integer;
    IsOrder: boolean;
  end;

var
  Map: array [0..42, 0..42, 1..2] of integer;
  Ant: array [1..20] of TAntStats;
  xAdd, yAdd, antN, maxX, maxY: integer;

procedure Init;
var
  x, y: integer;
begin
  Randomize;
  Fillchar(Map, SizeOf(map), 0);
  for x := 0 to 42 do
    for y := 0 to 42 do
      Map[x, y, 2] := 1;
  antN := 1;
  Ant[1].x := 1;
  Ant[1].y := 1;
  Ant[1].IsOrder := false;
  MaxX := 21;
  MaxY := 21;
end;

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;

procedure Discover(num: integer);
var
  x, y, x1, y1: integer;
begin
  x := Ant[num].x;
  y := Ant[num].y;
  for x1 := -1 to 1 do
    for y1 := -1 to 1 do
    begin
      if Map[x + x1, y + y1, 2] = 1 then
        Map[x + x1, y + y1, 2] := 2 else
      if Map[x + x1, y + y1, 2] = -1 then
        Map[x + x1, y + y1, 2] := -2;
      if sensors[x1 * xAdd, y1 * yAdd].isWall then
        Map[x + x1, y + y1, 1] := mpWall else
      if sensors[x1 * xAdd, y1 * yAdd].isEnemyHill then
        Map[x + x1, y + y1, 1] := mpEnemyBase else
      if sensors[x1 * xAdd, y1 * yAdd].isMyHill then
        Map[x + x1, y + y1, 1] := mpBase else
      if sensors[x1 * xAdd, y1 * yAdd].isFood then
        Map[x + x1, y + y1, 1] := mpFood else
        Map[x + x1, y + y1, 1] := mpEmpty;
    end;
end;

procedure GetOrder(num: integer);
var
  x, y, x1, y1, d, dmax: integer;
  ff: boolean;
begin
  if sensors[0, 0].isMyHill then
  begin
    Map[1, 1, 1] := mpBase;
    Ant[num].x := 1;
    Ant[num].y := 1;
    Ant[num].IsOrder := false;
  end;
  if (Map[Ant[num].orderx, Ant[num].ordery, 2] < 0) then
    Map[Ant[num].orderx, Ant[num].ordery, 2] := -Map[Ant[num].orderx, Ant[num].ordery, 2];
  if hasFood then
  begin
    Ant[num].IsOrder := true;
    Ant[num].orderx := 1;
    Ant[num].ordery := 1;
  end else
  begin
    Ant[num].IsOrder := true;
    x := Ant[num].x;
    y := Ant[num].y;
    ff := false;
    dmax := 100000;
    for x1 := 1 to maxX do
      for y1 := 1 to maxY do
      if ((Map[x1, y1, 2] = 2) and (Map[x1, y1, 1] = mpFood)) or (Map[x1, y1, 2] = 1) then
      begin
        d := abs(x - x1) + abs(y - y1);
        if (not ff) or (dmax > d) then
        begin
          dmax := d;
          Ant[num].orderx := x1;
          Ant[num].ordery := y1;
          ff := true;
        end;
      end;
    if not ff then
    begin
      Ant[num].orderx := MaxX;
      Ant[num].ordery := MaxY;
    end else
      Map[Ant[num].orderx, Ant[num].ordery, 2] := -1;
  end;
end;

procedure Move(num: integer);
var
  x1, y1, x2, y2, dx, dy: integer;
begin
  x1 := Ant[num].x;
  y1 := Ant[num].y;
  x2 := Ant[num].orderx;
  y2 := Ant[num].ordery;
  if x2 - x1 > 0 then
    dx := 1 else
  if x2 - x1 < 0 then
    dx := -1 else
    dx := 0;
  if y2 - y1 > 0 then
    dy := 1 else
  if y2 - y1 < 0 then
    dy := -1 else
    dy := 0;
  ////////////////////////////////////////
  dx := dx * xAdd;
  dy := dy * yAdd;
  if dx = 0 then
  begin
    if dy = 0 then
    begin
      if hasFood then
        result.actionType := aaPut else
      if (sensors[0, 0].isFood) and (not sensors[0, 0].isMyHill) then
        result.actionType := aaGet;
      Ant[num].IsOrder := false;
      if Map[x2, y2, 2] < 0 then
        Map[x2, y2, 2] := -Map[x2, y2, 2];
    end else
    begin
      if not sensors[0, dy].isWall then
        Ant[num].y := Ant[num].y + dy * yAdd;
      if dy = 1 then
        result.actionType := aaMoveDown else
        result.actionType := aaMoveUp;
    end;
  end else
  if dy = 0 then
  begin
    if not sensors[dx, 0].isWall then
      Ant[num].x := Ant[num].x + dx * xAdd;
    if dx = 1 then
      result.actionType := aaMoveRight else
      result.actionType := aaMoveLeft;
  end else
  if random(2) = 0 then
  begin
    if not sensors[0, dy].isWall then
      Ant[num].y := Ant[num].y + dy * yAdd;
    if dy = 1 then
      result.actionType := aaMoveDown else
      result.actionType := aaMoveUp;
  end else
  begin
    if not sensors[dx, 0].isWall then
      Ant[num].x := Ant[num].x + dx * xAdd;
    if dx = 1 then
      result.actionType := aaMoveRight else
      result.actionType := aaMoveLeft;
  end;
  ////////////////////////////////////////
end;

var
  num: integer;

begin
  if (memory^[mTime] = 0) and (sensors[0, 0].smell = 0) then
  begin
    Init;
    result.putSmell := true;
    result.smell := smStart;
    memory^[mNumber] := 1;
    if sensors[1, 0].isWall = false then
      xAdd := 1 else
      xAdd := -1;
    if sensors[0, 1].isWall = false then
      yAdd := 1 else
      yAdd := -1;
  end else
  if (sensors[0, 0].smell >= smStart) and (sensors[0, 0].smell <= smStart + maxAnts) then
  begin
    result.putSmell := true;
    result.smell := sensors[0, 0].smell + 1;
    memory^[mNumber] := sensors[0, 0].smell - smStart + 2;
    num := memory^[mNumber];
    Ant[num].x := 1;
    Ant[num].y := 1;
    Ant[num].IsOrder := false;
    antN := num;
    if antN = 11 then
    begin
      maxX := 41;
      maxY := 41;
    end;
  end else
    result.putSmell := false;
  inc(memory^[mTime]);
  num := memory^[mNumber];
  Discover(num);
  GetOrder(num);
  Move(num);
end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
end.
