(*------------------------------------------------------------
TEAM39
A
176
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library DelphiSamplePlayer;

uses
  Math,
  Ants in 'Ants.pas';

const
  PLAYER_NAME = 'Revengers';
  checkCells  = 5;

type
  HillPos = (_UNDEF, _LTop, _LBottom, _RTop, _RBottom);

var pnt  : PMemory;
    sens : TSensors;
    res  : TAntAction;
    x, y : array[0..10000] of longint;
    cnt  : longint;
    size : longint;

function getHillPos : HillPos;
var pst : byte;
 begin
  pst := pnt[0];
  if pst = 0 then result := _UNDEF else
  if pst = 1 then result := _LTop else
  if pst = 2 then result := _LBottom else
  if pst = 3 then result := _RTop else result := _RBottom;
 end;

procedure buildXY;
var i, k : longint;
 begin
  cnt := 0;
  for k := 0 to 2 * (size - 1) do
   if k mod 2 = 0 then begin
     for i := 0 to k do if (i < size) and (k - i < size) then begin
       x[cnt] := max(i, 21);
       y[cnt] := max(k - i, 21);
       cnt := cnt + 1;
      end;
   end else begin
     for i := k downto 0 do if (i < size) and (k - i < size) then begin
       x[cnt] := max(i, 21);
       y[cnt] := max(k - i, 21);
       cnt := cnt + 1;
      end;
   end;
 end;

function getId : byte;
 begin
  result := pnt[1];
 end;

procedure setId(id : byte);
 begin
  pnt[1] := id;
 end;

function getSize : byte;
 begin
  result := pnt[3];
 end;

procedure setSize(s : byte);
 begin
  pnt[3] := s;
 end;

procedure setTask(id : longint);
 begin
  pnt[5] := id div 255;
  pnt[6] := id and 255;
 end;

function getTask : longint;
var i : longint;
 begin
  i := pnt[5];
  i := i * 255 + pnt[6];
  result := i;
 end;

procedure initHillPosition;
var id : byte;
 begin
  if sens[-1, 0].isWall then begin
    if sens[0, -1].isWall then pnt[0] := 1 else pnt[0] := 2;
   end else begin
    if sens[0, -1].isWall then pnt[0] := 3 else pnt[0] := 4;
   end;

  id := sens[0, 0].smell + 1;
  res.putSmell := true;
  res.smell := id;
  setId(id);

  setSize(41);
  size := getSize;

  pnt[3] := 0; // cur x
  pnt[4] := 0; // cur y

  setTask(getId * checkCells + (checkCells - 1));
  pnt[7] := 0; // total number of ants

 end;

function hasEnemy : boolean;
 begin
  result := sens[-1, 0].isEnemy or sens[1, 0].isEnemy or
            sens[0, -1].isEnemy or sens[0, 1].isEnemy;
 end;

function getAAT(dx, dy : longint) : TAntActionType;
 begin
  if dx = 1 then begin
    if (getHillPos = _LTop) or (getHillPos = _LBottom)
      then getAAT := aaMoveRight
      else getAAT := aaMoveLeft;
   end else
  if dx = -1 then begin
    if (getHillPos = _RTop) or (getHillPos = _RBottom)
      then getAAT := aaMoveRight
      else getAAT := aaMoveLeft;
   end else
  if dy = 1 then begin
    if (getHillPos = _LBottom) or (getHillPos = _RBottom)
      then getAAT := aaMoveUp
      else getAAT := aaMoveDown;
   end else
  if dy = -1 then begin
    if (getHillPos = _LTop) or (getHillPos = _RTop)
      then getAAT := aaMoveUp
      else getAAT := aaMoveDown;
   end else
     getAAT := aaBiteLeft;
 end;

procedure PeacefullAnt(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction);
var dx, dy, k, qx, qy : longint;
    px, py : TAntActionType;
 begin
  buildXY;
  if hasFood then begin
    dx := -1;
    dy := -1;
    px := getAAT(dx, 0);
    py := getAAT(0, dy);

      qx := dx;
      if dx <> 0 then begin
        if px = aaMoveLeft then qx := -1 else qx := 1;
       end;
      py := getAAT(0, dy);
      qy := dy;
      if dy <> 0 then begin
        if py = aaMoveUp then qy := -1 else qy := 1;
       end;
      if sens[qx, 0].isWall then dx := 0;
      if sens[0, qy].isWall then dy := 0;
      result.actionType := aaMoveLeft;

    if sens[0, 0].isMyHill then begin
      pnt[3] := 0;
      pnt[4] := 0;
      if pnt[7] = 0 then begin
        pnt[7] := sens[0, 0].smell;
        if getid = pnt[7] then begin
          result.putSmell := true;
          result.smell := 0;
         end;
       end;
      result.actionType := aaPut;
     end else
    if (dx <> 0) and (dy <> 0) then begin
      if random(2) = 1 then begin
        result.actionType := px;
        pnt[3] := pnt[3] - 1;
       end else begin
        result.actionType := py;
        pnt[4] := pnt[4] - 1;
       end;
     end else
    if (dx <> 0) then begin
      result.actionType := px;
      pnt[3] := pnt[3] - 1;
     end else
    if (dy <> 0) then begin
      result.actionType := py;
      pnt[4] := pnt[4] - 1;
     end;
   end else begin
    if hasEnemy and (random(7) < 5) then begin
      if sens[-1, 0].isEnemy then result.actionType := aaBiteLeft;
      if sens[1, 0].isEnemy then result.actionType := aaBiteRight;
      if sens[0, -1].isEnemy then result.actionType := aaBiteUp;
      if sens[0, 1].isEnemy then result.actionType := aaBiteDown;
     end else begin
      if (sens[0, 0].isFood) and (pnt[3] + pnt[4] > 0) then begin
        result.actionType := aaGet;
        exit;
       end;
      k := 0;
      while true do begin
        k := k + 1;
        dx := 0;
        dy := 0;
        if pnt[3] < x[getId] then dx := 1;
        if pnt[4] < y[getId] then dy := 1;
        if pnt[3] > x[getId] then dx := -1;
        if pnt[4] > y[getId] then dy := -1;
        if (dx = 0) and (dy = 0) then begin
          if getId mod checkCells = 1 then setId(getId + 1)
           else setId(getId + pnt[7] * checkCells);
          if pnt[7] = 0 then setId(getId + checkCells);
         end else break;
        if getId > cnt then setId(cnt);
        if k > 4 then break;
       end;
      //if (dx = 0) and (dy = 0) then while true do;
      
      px := getAAT(dx, 0);
      py := getAAT(0, dy);
      qx := dx;
      if dx <> 0 then begin
        if px = aaMoveLeft then qx := -1 else qx := 1;
       end;
      py := getAAT(0, dy);
      qy := dy;
      if dy <> 0 then begin
        if py = aaMoveUp then qy := -1 else qy := 1;
       end;
      if sens[qx, 0].isWall then dx := 0;
      if sens[0, qy].isWall then dy := 0;

      if (dx = 0) and (dy = 0) then begin
        case random(4) of
          0 : result.actionType := aaMoveLeft;
          1 : result.actionType := aaMoveRight;
          2 : result.actionType := aaMoveDown;
          3 : result.actionType := aaMoveUp;
         end; 
        exit;
       end;

      if (dx <> 0) and (dy <> 0) then begin
        if random(2) = 1 then begin
          result.actionType := px;
          pnt[3] := pnt[3] + dx;
         end else begin
          result.actionType := py;
          pnt[4] := pnt[4] + dy;
         end;
       end else
      if (dx <> 0) then begin
        result.actionType := px;
        pnt[3] := pnt[3] + dx;
       end else
      if (dy <> 0) then begin
        result.actionType := py;
        pnt[4] := pnt[4] + dy;
       end;
     end;
   end;
 end;

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;
 begin
  pnt  := memory;
  sens := sensors;
  res.putSmell := false;
  res.smell := 0;
  if getHillPos = _UNDEF then initHillPosition;
  result := res;
  {if getId <= 10 then} PeacefullAnt(sensors, hasFood, memory, result);
 end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;

begin
 randseed := 30051985;
end.
