/*------------------------------------------------------------
TEAM45
A
175
Target: AntsCpp; Platform: Win32; Comment: MS Visual C++ 6 (Ants, dll)
------------------------------------------------------------*/
#include "windows.h"
#include "Ants.h"
#include <math.h>
//#include	<stdio.h>

#define PLAYER_NAME "T34"

struct FIELDMEM
{
   unsigned x : 6;    // 0..7   (3 bits)
   unsigned y : 6;    // 0..31  (6 bits)
   unsigned type : 1;    // 0..12  (5 bits)
};

enum emyOrder {NO = 0, HOME, SEEK, BRING};

struct ANTMEM
{
	unsigned id : 5;
	unsigned x : 6;
	unsigned y : 6;
	unsigned tx : 6;
	unsigned ty : 6;
	unsigned L : 1;
	unsigned U : 1;
	unsigned tenOfUs : 1;
	unsigned myTurn : 11;
	unsigned myOrder : 4;
};

const int GUARDS = 0;

void goTO(int x, int y, AntSensor sensors[3][3], bool hasFood, ANTMEM& mymem, AntAction& result)
{
		if (mymem.x > x)
		{
//			--mymem.x;
			result.actionType = MOVE_LEFT;
		}
		else if (mymem.x < x)
		{
//			++mymem.x;
			result.actionType = MOVE_RIGHT;
		}
		else if (mymem.y > y)
		{
///			--mymem.y;
			result.actionType = MOVE_UP;
		}
		else if (mymem.y < y)
		{
//			++mymem.y;
			result.actionType = MOVE_DOWN;
		}
}

void goHOME(AntSensor sensors[3][3], bool hasFood, ANTMEM& mymem, AntAction& result)
{
	goTO(0, 0, sensors, hasFood, mymem, result);
}

bool isValid(int x, int y)
{
	return x <= 21 && y <= 21 && x >= 1 && y >= 1;
}

#include	<stdlib.h>

void goo(AntSensor sensors[3][3], bool hasFood, ANTMEM& mymem, AntAction& result)
{
	if (mymem.id <= GUARDS && (mymem.id & 1))
	{
		if (!sensors[1][2].isWall)
		{
			goTO(mymem.x, mymem.y - 1, sensors, hasFood, mymem, result);
			return;
		}
		if (!sensors[0][1].isWall)
		{
			goTO(mymem.x - 1, mymem.y, sensors, hasFood, mymem, result);
			return;
		}
		if (!sensors[1][0].isWall)
		{
			goTO(mymem.x, mymem.y + 1, sensors, hasFood, mymem, result);
			return;
		}
		if (!sensors[2][1].isWall)
		{
			goTO(mymem.x + 1, mymem.y, sensors, hasFood, mymem, result);
			return;
		}
	}
	else
	{
		if (!sensors[1][0].isWall)
		{
			goTO(mymem.x, mymem.y + 1, sensors, hasFood, mymem, result);
			return;
		}
		if (!sensors[2][1].isWall)
		{
			goTO(mymem.x + 1, mymem.y, sensors, hasFood, mymem, result);
			return;
		}
		if (!sensors[1][2].isWall)
		{
			goTO(mymem.x, mymem.y - 1, sensors, hasFood, mymem, result);
			return;
		}
		if (!sensors[0][1].isWall)
		{
			goTO(mymem.x - 1, mymem.y, sensors, hasFood, mymem, result);
			return;
		}
	}
}

void doSEEK(AntSensor sensors[3][3], bool hasFood, ANTMEM& mymem, AntAction& result)
{
	static int t = 1;
	if (t == 1)
	{
		srand(512341);
		t = 0;
	}
	if (sensors[1][1].isFood)
	{
		mymem.myOrder = HOME;
		mymem.tx = mymem.x;
		mymem.ty = mymem.y;
		goHOME(sensors, hasFood, mymem, result);
		return;
	}

//		printf("QW id=%d, x = %d, y = %d\n", (int) mymem.id, (int)mymem.x, (int)mymem.y);
	while (true)
	{
		int t = rand() % 4;
		switch (t)
		{
			case 0: if (!sensors[1][0].isWall)
			{
				goTO(mymem.x, mymem.y + 1, sensors, hasFood, mymem, result);
				return;
			}
			case 1: if (!sensors[2][1].isWall)
			{
				goTO(mymem.x + 1, mymem.y, sensors, hasFood, mymem, result);
				return;
			}
			case 2:if (!sensors[1][2].isWall)
			{
				goTO(mymem.x, mymem.y - 1, sensors, hasFood, mymem, result);
				return;
			}
			case 3: if (!sensors[0][1].isWall)
			{
				goTO(mymem.x - 1, mymem.y, sensors, hasFood, mymem, result);
				return;
			}
		}
	}
}


AntAction GetAntAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY])
{
	AntAction result;
	if (memory[10] == 0)
	{
		bool fr = false;
		bool sm = false;
		{
			for (int i = 0; i < 3; ++i)
				for (int j = 0; j < 3; ++j)
				{
					fr = fr || sensors[i][j].isFriend;
					sm = sm || (sensors[1][1].smell == 3);
				}
		}	
		if (!fr || sm)
			memory[10] = 1;
		else
			memory[10] = 2;
	}

	if (memory[10] == 2 || sensors[1][1].isMyHill /*|| true*/)
	{

		if (rand() % 3 != 1)
				{
	int tt = 0;

    if (sensors[0][1].isMyHill && sensors[0][1].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_LEFT;
		++tt;
		return result;
	}
	if (sensors[2][1].isMyHill && sensors[2][1].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_RIGHT;
		++tt;
		return result;
	}
	if (sensors[1][0].isMyHill && sensors[1][0].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_UP;
		++tt;
		return result;
	}
	if (sensors[1][2].isMyHill && sensors[1][2].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_DOWN;
		++tt;
		return result;
	}
		}

		if (rand() % 2)
		{
	int tt = 0;

    if (sensors[0][1].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_LEFT;
		++tt;
		return result;
	}
	if (sensors[2][1].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_RIGHT;
		++tt;
		return result;
	}
	if (sensors[1][0].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_UP;
		++tt;
		return result;
	}
	if (sensors[1][2].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_DOWN;
		++tt;
		return result;
	}
		}

	if (hasFood && sensors[1][1].isMyHill) result.actionType = PUT;
	else if (!hasFood && !sensors[1][1].isMyHill && sensors[1][1].isFood) result.actionType = GET;
	else
	{
		char spiralSize = max(10, memory[0]);
		char position = memory[1];
		char direction = memory[2];
		position = position % spiralSize;
		if (position == 0)
		{
			if (direction == 3) spiralSize = max(10, (spiralSize + 1) % 41);
			direction = (direction + 1) % 4;
		}
		position++;
		memory[0] = spiralSize;
		memory[1] = position;
		memory[2] = direction;
		result.actionType = AntActionType(direction);
	}
	return result;

	}

//////////////////////////////
	
//	printf("\n\n");
//	AntAction result;
	result.putSmell = true;
	if (!sensors[1][1].isFriend)
		result.smell = 3;
	else
		result.smell = 0;

	ANTMEM& mymem = *((ANTMEM*)memory);
//	printf("I: id=%d, turn=%d, smell = %d, x = %d, y = %d, mymem = %p\n", (int)mymem.id, (int)mymem.myTurn, (int)sensors[1][1].smell, (int)mymem.x, (int)mymem.y, memory);
	FIELDMEM field = *(FIELDMEM*)&sensors[1][1].smell;
//				mymem.myOrder = SEEK;
/*	if (sensors[1][1].isMyHill)
	{
		doSEEK(sensors, hasFood, mymem, result);
		return result;
	}*/
	result.actionType = PUT;

	int tt = 0;

    if (sensors[0][1].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_LEFT;
		++tt;
		return result;
	}
	if (sensors[2][1].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_RIGHT;
		++tt;
		return result;
	}
	if (sensors[1][0].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_UP;
		++tt;
		return result;
	}
	if (sensors[1][2].isEnemy && (!tt || (rand() % 3)))
	{
		result.actionType = BITE_DOWN;
		++tt;
		return result;
	}


	return result;
/*
	if (mymem.myTurn == 0)
	{
//		printf("WHO AM I?\n");

		mymem.x = 0;
		mymem.y = 0;
		mymem.L = sensors[0][1].isWall;
		mymem.U = sensors[1][0].isWall;
		//init
		bool fr = false;
		{
			for (int i = 0; i < 3; ++i)
				for (int j = 0; j < 3; ++j)
					fr = fr || sensors[i][j].isFriend;
		}
		if (!fr)
		{
			//i'm captain
//			printf("I'm the first\n");
			mymem.id = 1;
			result.putSmell = true;
			result.smell = 1;
			goo(sensors, hasFood, mymem, result);
		}
		else
		{
			mymem.id = sensors[1][1].smell + 1;
//			printf("I'm number %d\n", mymem.id);
			result.putSmell = true;
			result.smell = mymem.id;
			goo(sensors, hasFood, mymem, result);
		}
	}
	else if (mymem.myTurn == 1)
	{
//		printf("WHO ARE THEY?\n");
//		mymem.tenOfUs = sensors[1][1].smell < 11;
//		printf("%d friends\n", (int)sensors[1][1].smell - 1);
//		result.putSmell = false;
//		result.actionType = PUT;
		if (mymem.id > GUARDS)
		{
			mymem.myOrder = SEEK;
			doSEEK(sensors, hasFood, mymem, result);
		}
	}
	else
	{
		if (mymem.id <= GUARDS)
		{
//			printf("I'm GUARD\n");
			{
				result.actionType = PUT;
				result.putSmell = false;
				if (mymem.id & 1)
				{
					if (sensors[0][1].isEnemy)
						result.actionType = BITE_LEFT;
					else if (sensors[2][1].isEnemy)
						result.actionType = BITE_RIGHT;
					else if (sensors[1][0].isEnemy)
						result.actionType = BITE_UP;
					else if (sensors[1][2].isEnemy)
						result.actionType = BITE_DOWN;
				}
				else
				{
					if (sensors[1][0].isEnemy)
						result.actionType = BITE_UP;
					else if (sensors[1][2].isEnemy)
						result.actionType = BITE_DOWN;
					else if (sensors[0][1].isEnemy)
						result.actionType = BITE_LEFT;
					else if (sensors[2][1].isEnemy)
						result.actionType = BITE_RIGHT;
				}
			}
		}
		else
		{
			if (mymem.myOrder == HOME)
			{
//				printf("I go HOME\n");
				if (mymem.x != 0 || mymem.y != 0)
					goHOME(sensors, hasFood, mymem, result);
				else
				{
					if (hasFood)
					{
						result.actionType = PUT;
					}
					else
					{
						int xx = field.x, yy = field.y;
						if (isValid(xx, yy))
						{
							result.putSmell = true;
							field.x = mymem.tx;
							field.y = mymem.ty;
							result.smell = *(int*)&field;
							mymem.myOrder = BRING;
							mymem.tx = xx;
							mymem.ty = yy;
							goTO(mymem.tx, mymem.ty, sensors, hasFood, mymem, result);
						}
						else
						{
							result.putSmell = true;
							field.x = mymem.tx;
							field.y = mymem.ty;
							result.smell = *(int*)&field;
							mymem.myOrder = BRING;
							goTO(mymem.tx, mymem.ty, sensors, hasFood, mymem, result);
						}
					}
				}
			}
			else if (mymem.myOrder == BRING)
			{
//				printf("I go for food\n");
				if (sensors[1][1].isFood)
				{
					mymem.tx = mymem.x;
					mymem.ty = mymem.y;
					result.actionType = GET;
					mymem.myOrder = HOME;
				}
				else
				{
					if (mymem.tx != mymem.x || mymem.ty != mymem.y)
						goTO(mymem.tx, mymem.ty, sensors, hasFood,  mymem, result);
					else
					{
						mymem.myOrder = SEEK;
						doSEEK(sensors, hasFood,  mymem, result);
					}
				}
			}

			else if (mymem.myOrder == SEEK)
			{
//				printf("I go seek for food\n");
				doSEEK(sensors, hasFood,  mymem, result);
			}
		}
	}
	++mymem.myTurn;
	return result;
	*/
}

char* __stdcall GetName()
{
	return PLAYER_NAME;
}
